import 'wc_dimension.dart';
import 'wp_attribute.dart';
import 'wp_category.dart';
import 'wp_image.dart';
import 'package:lab_rat_storage/lab_rat_storage.dart';
import 'wp_tag.dart';

class WCProduct extends JsonObject{
    int id;
    int parentId;

    String slug;
    String permalink;

    String name;
    String description;
    String shortDescription;    
    
    String _dateCreated;
    String _dateModified;
    
    DateTime get dateCreated  => DateTime.parse(_dateCreated);
    void set dateCreated(DateTime date){ _dateCreated = date.toString();}

    DateTime get dateModified  => DateTime.parse(_dateModified);
    void set dateModified(DateTime date){ _dateModified = date.toString();}
    
    bool purchasable;

    String type;
    String status;
    bool featured;
    bool catalogVisibility;

    int price;
    int regularPrice;
    int salePrice;
    bool onSale;
    String price_html;

    List<int> crossSaleIds;
    List<int> upsaleIds;

    int weight;

    List<WPTag> tags;
    List<WPImage> images;
    List<WPCategory> categories;
    WCDimensions dimensions;
    List<WCAttribute> attributes;

    @override
    void fromJson(target) {
        id = target['id'];
        parentId = target['parent_id'];

        slug = target['slug'];
        permalink = target['permalink'];

        name = target['name'];
        description = target['description'];
        shortDescription = target['short_description'];

        dateCreated = target['date_created'];
        dateModified = target['date_modified'];

        purchasable = target['purchasable'];

        type = target['type'];
        status = target['status'];
        featured = target['featured'];
        catalogVisibility = target['catalog_visibility'];

        price = target['price'];
        regularPrice = target['regular_price'];
        salePrice = target['sale_price'];
        onSale = target['on_sale'];
        price_html = target['price_html'];

        crossSaleIds = target['cross_sale_ids'];
        upsaleIds = target['upsale_ids'];

        weight = target['weight'];

        tags = [];
        target['tags'].forEach((t){
            tags.add(new WPTag()..fromJson(t));
        });

        images = [];
        target['images'].forEach((i){
            images.add(new WPImage()..fromJson(i));
        });

        categories = [];
        target['categories'].forEach((c){
            categories.add(new WPCategory()..fromJson(c));
        });

        attributes = [];
        target['attributes'].forEach((a){
            attributes.add(new WCAttribute()..fromJson(a));
        });

        dimensions = new WCDimensions()..fromJson(target['dimensions']);


    }
}

